/* Diverses - geklaut aus A/UX usw. um CAP auf NetAtalk aufzusetzen */
/* verbrochen von Chris Benndorf (chrisb@ganzfix.duew.eunet.de) */

#define  DDP_DATA_SIZE              586
typedef u_short at_net;                 /* AppleTalk network number */
typedef u_char  at_node;                /* AppleTalk node number */
typedef u_char  at_socket;              /* AppleTalk socket number */

typedef struct at_inet {
    at_net      net;                    /* Network Address */
    at_node     node;                   /* Node number */
    at_socket   socket;                 /* Socket number */
} at_inet_t;

typedef struct at_retry {
    short       interval;               /* Retry interval in seconds */
    short       retries;                /* Maximum number of retries */
    u_char      backoff;                /* Retry backoff, must be 1 through 4 */
} at_retry_t;

typedef struct {
#if defined(vax) || defined(sequent) || defined(sun386)
        u_short    length:10,           /* Datagram length */
                   hopcount:4,
                   unused:2;
#else
        u_short    unused:2,
                   hopcount:4,
                   length:10;           /* Datagram length */
#endif
        u_short    checksum;            /* Checksum */
        at_net     dst_net;             /* Destination network number */
        at_net     src_net;             /* Source network number */
        at_node    dst_node;            /* Destination node ID */
        at_node    src_node;            /* Source node ID */
        at_socket  dst_socket;          /* Destination socket number */
        at_socket  src_socket;          /* Source socket number */
        u_char     type;                /* Protocol type */
        char       data[DDP_DATA_SIZE];
} at_ddp_t;

typedef struct {
        u_short         network_up;
        int             flags;          /* to indicate what type
                                         * of network interface the
                                         * default net is (ethertalk/
                                         * localtalk?)
                                         */
        at_inet_t       node_addr;
        at_inet_t       router_addr;
} at_ddp_cfg_t;

#define NBP_NVE_STR_SIZE        32      /* Maximum NBP tuple string size */
typedef struct at_nvestr {
        u_char          len;
        u_char          str[NBP_NVE_STR_SIZE];
} at_nvestr_t;

typedef struct at_entity {
        at_nvestr_t     object;
        at_nvestr_t     type;
        at_nvestr_t     zone;
} at_entity_t;

